#!/usr/bin/ruby

class Dropzone
  $VERBOSE = nil

  def determinate(value)
    output = (value ? "Determinate: 1" : "Determinate: 0")
    send_output(output)
  end
  
  def begin(message)
    send_output("Begin_Message: #{message}")
  end
  
  def finish(message)
    send_output("Finish_Message: #{message}")
  end

  def fail(message)
    send_output("Fail: #{message}")
    Process.exit
  end

  def alert(title, message)
    send_output("Alert_Title: #{title}")
    send_output("Alert: #{message}")
  end
  
  def error(title, message)
    send_output("Error_Title: #{title}")
    send_output("Error: #{message}")
    Process.exit
  end
  
  def percent(value)
    send_output("Progress: #{value}")
  end
  
  def url(url, title=nil)
    send_output("URL_Title: #{title}") if title
    (url ? send_output("URL: #{url}") : send_output("URL: 0"))
  end
  
  def text(text)
    (text ? send_output("Text: #{text}") : send_output("Text: 0"))
  end

  def temp_folder
    temp_folder = ENV['support_folder'] + '/' + 'Temp'
    Dir.mkdir temp_folder unless File.directory?(temp_folder)
    return temp_folder
  end

  def save_value(value_name, value)
    send_output("Save_Value_Name: #{value_name}")
    send_output("Save_Value: #{value}")
  end

  def cocoa_dialog(arg_str)
    Dir.chdir($runner_path) do
      `./CocoaDialog #{arg_str}`
    end
  end

  def inputbox(title, prompt_text, field_name="Filename")
    output = cocoa_dialog("inputbox --button1 \"OK\" --button2 \"Cancel\" --title \"#{title}\" --e --informative-text \"#{prompt_text}\"")
    button, input = output.split("\n")
    
    if button == "2"
      fail("Cancelled")
    end
    
    unless input
      fail("#{field_name} cannot be empty.")
    end
    
    return input
  end

  def replace_dialog(arg_str)
    Dir.chdir($runner_path) do
      `./ReplaceDialog.app/Contents/MacOS/ReplaceDialog #{arg_str}`
    end
  end

  def read_clipboard
    IO.popen('pbpaste') {|clipboard| clipboard.read}
  end

  def send_output(line)
    puts line.gsub(/\n/, "[;n")
    # Block until acknowledgement
    line = $stdin.gets
  end
end
